// filesystem.h

#ifndef FILESYSTEM_H
#define FILESYSTEM_H

#define MAX_FILES 16
#define MAX_FILENAME_LEN 32
#define MAX_FILE_SIZE 256

typedef struct {
    char name[MAX_FILENAME_LEN];
    char data[MAX_FILE_SIZE];
    int size;
    int in_use;
} File;

// 文件系统操作函数声明
void fs_init();
int fs_create(const char *filename);
int fs_delete(const char *filename);
int fs_write(const char *filename, const char *data, int size);
int fs_read(const char *filename, char *buffer, int buffer_size);
void fs_list();

#endif // FILESYSTEM_H
