// kernel.h

#ifndef KERNEL_H
#define KERNEL_H

// UART 基地址和状态寄存器
#define UART_BASE 0x10000000
#define UART_LSR (UART_BASE + 0x05)
#define UART_LSR_DR 0x01

// UART 函数声明
void uart_putc(char c);
void uart_puts(const char *s);
char uart_getc();
void clear_screen();
void print_prompt();

// 字符串函数声明
int strcmp(const char *s1, const char *s2);
int strncmp_(const char *s1, const char *s2, unsigned int n);

// 任务调度相关声明
void schedule();
void delay();

// 内存管理函数声明
void *simple_malloc(int size);
void simple_free();

#endif // KERNEL_H
