// memory.c

#define HEAP_SIZE 1024  // 定义堆大小为 1024 字节
static char heap[HEAP_SIZE];
static char *free_ptr = heap;  // 空闲指针，指向下一个可用的内存位置

// 简单的 malloc 实现：分配指定大小的内存
void *simple_malloc(int size) {
    if (free_ptr + size > heap + HEAP_SIZE) {
        return 0;  // 内存不足
    }
    void *allocated = free_ptr;
    free_ptr += size;
    return allocated;
}

// 简单的 free 实现：回收所有内存
void simple_free() {
    free_ptr = heap;
}
