// process.c

#include "kernel.h"

#define NUM_TASKS 2

typedef void (*task_func)();

struct task {
    task_func func;
    int active;
};

int current_task = 0;
int task_run_count = 5;  // 默认任务运行次数

// 任务 1
void task1() {
    for (int i = 0; i < task_run_count; i++) {
        uart_puts("Task 1 running...\n");
        delay();
    }
    uart_puts("Task 1 finished.\n");
}

// 任务 2
void task2() {
    for (int i = 0; i < task_run_count; i++) {
        uart_puts("Task 2 running...\n");
        delay();
    }
    uart_puts("Task 2 finished.\n");
}

struct task tasks[NUM_TASKS] = {
    {task1, 1},
    {task2, 1}
};

// 简单的任务调度函数
void schedule(int run_count) {
    task_run_count = run_count;
    for (int i = 0; i < NUM_TASKS; i++) {
        current_task = i;
        tasks[current_task].func();
    }
}

// 延迟函数
void delay() {
    for (volatile int i = 0; i < 1000000; i++);
}
