// string.c

#include "kernel.h"
#include "string.h"

#define NULL ((void *)0)  // 定义 NULL

// 自定义字符串拷贝函数
char *strncpy_(char *dest, const char *src, unsigned int n) {
    unsigned int i;
    for (i = 0; i < n && src[i] != '\0'; i++) {
        dest[i] = src[i];
    }
    for (; i < n; i++) {
        dest[i] = '\0';
    }
    return dest;
}

// 自定义查找字符在字符串中的首次出现
char *strchr_(const char *s, int c) {
    while (*s) {
        if (*s == (char)c) {
            return (char *)s;
        }
        s++;
    }
    return NULL;
}

// 自定义计算字符串长度
unsigned int strlen_(const char *s) {
    unsigned int len = 0;
    while (*s++) {
        len++;
    }
    return len;
}

// 字符串比较函数
int strcmp_(const char *s1, const char *s2) {
    while (*s1 && *s1 == *s2) {
        s1++;
        s2++;
    }
    return (unsigned char)*s1 - (unsigned char)*s2;
}

// 字符串前 n 个字符比较函数
int strncmp_(const char *s1, const char *s2, unsigned int n) {
    for (unsigned int i = 0; i < n; i++) {
        if (s1[i] != s2[i] || s1[i] == '\0' || s2[i] == '\0') {
            return (unsigned char)s1[i] - (unsigned char)s2[i];
        }
    }
    return 0;
}
